CREATE SEQUENCE "rechnungsid" start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;

CREATE SEQUENCE "kundenid" start 1 increment 1 maxvalue 2147483647 minvalue 1  cache 1 ;

CREATE TABLE "kunden" (
	"kundennummer" integer DEFAULT nextval('kundenid'::text) NOT NULL,
	"vorname" character varying(50),
	"name" character varying(50),
	"firma" character varying(80),
	"strasse" character varying(100),
	"plz" character varying(12),
	"ort" character varying(50),
	"tel" character varying(40),
	"fax" character varying(40),
	"funk" character varying(40),
	"email" character varying(100),
	"business" boolean DEFAULT 'f'::bool,
	Constraint "kunden_pkey" Primary Key ("kundennummer")
);

CREATE TABLE "rechnung" (
	"rechnungsnummer" integer DEFAULT nextval('rechnungsid'::text) NOT NULL,
	"kundennummer" integer NOT NULL,
	"datum" date,
	"zahldatum" date,
	"mitarbeiter" character varying(50),
	"status" character varying(30),
	"mahnungstyp" boolean DEFAULT 't'::bool,
	"gesamtbetrag" numeric(30,2),
	"kommentar" character varying(255),
	Constraint "rechnung_pkey" Primary Key ("rechnungsnummer")
);

CREATE TABLE "rechnungsposten" (
	"rechnungsnummer" integer NOT NULL,
	"artikelname" character varying(255) NOT NULL,
	"einzelpreis" numeric(15,2),
	"menge" smallint
);

CREATE TABLE "todo" (
	"priority" character varying(10),
	"what" text
);

