with Glib; use Glib;
with Gtk; use Gtk;
with Gdk.Types;       use Gdk.Types;
with Gtk.Widget;      use Gtk.Widget;
with Gtk.Enums;       use Gtk.Enums;
with Gtkada.Handlers; use Gtkada.Handlers;
with Callbacks_Project1; use Callbacks_Project1;
with Dialog1_Pkg.Callbacks; use Dialog1_Pkg.Callbacks;

package body Dialog1_Pkg is

procedure Gtk_New (Dialog1 : out Dialog1_Access) is
begin
   Dialog1 := new Dialog1_Record;
   Dialog1_Pkg.Initialize (Dialog1);
end Gtk_New;

procedure Initialize (Dialog1 : access Dialog1_Record'Class) is
   pragma Suppress (All_Checks);
begin
   Gtk.Dialog.Initialize (Dialog1);
   Set_Title (Dialog1, "About AdaBill");
   Set_Policy (Dialog1, True, True, False);
   Set_Position (Dialog1, Win_Pos_Mouse);
   Set_Modal (Dialog1, False);
   Grab_Focus (Dialog1);

   Dialog1.Dialog_Vbox1 := Get_Vbox (Dialog1);
   Set_Homogeneous (Dialog1.Dialog_Vbox1, False);
   Set_Spacing (Dialog1.Dialog_Vbox1, 0);

   Dialog1.Dialog_Action_Area1 := Get_Action_Area (Dialog1);
   Set_Border_Width (Dialog1.Dialog_Action_Area1, 10);
   Set_Homogeneous (Dialog1.Dialog_Action_Area1, True);
   Set_Spacing (Dialog1.Dialog_Action_Area1, 5);

   Gtk_New (Dialog1.Button26, "OK");
   Set_Relief (Dialog1.Button26, Relief_Normal);
   Pack_Start (Dialog1.Dialog_Action_Area1, Dialog1.Button26, False, False, 0);
   Button_Callback.Connect
     (Dialog1.Button26, "clicked",
      Button_Callback.To_Marshaller (On_Close_About_Clicked'Access));

   Gtk_New_Vbox (Dialog1.Vbox13, False, 0);
   Pack_Start (Dialog1.Dialog_Vbox1, Dialog1.Vbox13, False, False, 0);

   Gtk_New (Dialog1.Label108, "AdaBill 0.0.8 (2001/12/19)");
   Set_Alignment (Dialog1.Label108, 0.5, 0.1);
   Set_Padding (Dialog1.Label108, 0, 8);
   Set_Justify (Dialog1.Label108, Justify_Center);
   Set_Line_Wrap (Dialog1.Label108, False);
   Pack_Start (Dialog1.Vbox13, Dialog1.Label108, False, False, 0);

   Gtk_New (Dialog1.Label109, "Adabill is a multi-platform business-solution.");
   Set_Alignment (Dialog1.Label109, 0.5, 0.5);
   Set_Padding (Dialog1.Label109, 16, 3);
   Set_Justify (Dialog1.Label109, Justify_Center);
   Set_Line_Wrap (Dialog1.Label109, False);
   Pack_Start (Dialog1.Vbox13, Dialog1.Label109, False, False, 0);

   Gtk_New (Dialog1.Label110, "See http://adi.thur.de/adabill.html" & ASCII.LF & "" & ASCII.LF & "Author: Adrian Knoth (adi@thur.de)");
   Set_Alignment (Dialog1.Label110, 0.5, 0.5);
   Set_Padding (Dialog1.Label110, 0, 0);
   Set_Justify (Dialog1.Label110, Justify_Center);
   Set_Line_Wrap (Dialog1.Label110, False);
   Pack_Start (Dialog1.Vbox13, Dialog1.Label110, False, False, 0);

end Initialize;

end Dialog1_Pkg;
