-- pg2.adb
-- Mario Amado Alves
-- 2000-01-18

with Ada.Strings.Fixed;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;
with Pg2.Interface;

package body Pg2 is

   package Interface1 is new Pg2.Interface;

   procedure Disconnect is
   begin
     Interface1.Disconnect;
   end Disconnect;

   procedure Submit(
     Command: in Unbounded_String;
     Result: in out Result_Type)
   is
     N: Integer;
   begin
         N := Interface1.Submit(Command, Result.Index);
         Result.Index := N;
         Result.OK := Interface1.OK(Result.Index);
         if Result.OK then
            Result.Tuples := Interface1.Tuples(Result.Index);
            if Result.Tuples then
               Result.Tuples_Qt := Interface1.Tuples_Qt(Result.Index);
               Result.Fields_Qt := Interface1.Fields_Qt(Result.Index);
               Result.Message := To_Unbounded_String(
                  "OK (" & Result.Tuples_Qt'Img & " tuples).");
            else
               Result.Message := To_Unbounded_String("OK (no tuples).");
            end if;
         else
            Result.Message := To_Unbounded_String(
               "ERROR: " & To_String(Interface1.Error_Message));
         end if;  
      end Submit;
   
      procedure Get(
      Result: in out Result_Type;
      Tuple: in Index_Type;
      Field: in Index_Type;
      Data: out Unbounded_String) is
      begin
         Data := Interface1.Get(Result.Index, Tuple, Field);
      -- update Result?
      end Get;
   
      procedure Forget(Result: in out Result_Type) is
         Empty_Result: Result_Type;
      begin
         Interface1.C_Forget(Interface1.To_C_Int(Result.Index));
         Result := Empty_Result;
      end Forget;
   
      procedure Escape(S: in out Unbounded_String) is
         Escape_Chars: String := "'";
         I: Integer := 1;
         J: Integer;
      begin
         while I <= Length(S) loop
            J := Ada.Strings.Fixed.Index(Escape_Chars, Slice(S, I, I));
            if J > 0 then
               Insert(S, I, "\");
               I := I + 1;
            end if;
            I := I + 1;
         end loop;
      end Escape;
   
      function Escape(S: Unbounded_String)
      return Unbounded_String
      is
         S2: Unbounded_String := S;
      begin
         Escape(S2);
         return(S2);
      end Escape;
   
   -- procedure Unescape(S: in out Unbounded_String) is
   --   I: Integer := 1;
   -- begin
   --   while I <= Length(S) loop
   --     if Element(S) = '\' then
   --       Delete(S, I, I);
   --     else
   --       I := I + 1;
   --     end if;
   --   end loop;
   -- end Unescape;
   
   -- function Unescape(S: Unbounded_String)
   --   return Unbounded_String
   -- is
   --   S2: Unbounded_String := S;
   -- begin
   --   Unescape(S2);
   --   return(S2);
   -- end Unescape;

begin

  Interface1.C_Connect(Interface1.To_C_String(Parameters));
     
end Pg2;


