with System; use System;
with Glib; use Glib;
with Gdk.Event; use Gdk.Event;
with Gdk.Types; use Gdk.Types;
with Gtk.Accel_Group; use Gtk.Accel_Group;
with Gtk.Object; use Gtk.Object;
with Gtk.Enums; use Gtk.Enums;
with Gtk.Style; use Gtk.Style;
with Gtk.Widget; use Gtk.Widget;

with Gtk.Main;

with sql; use sql;
with window1_pkg; use window1_pkg;
with dialog1_pkg; use dialog1_pkg;

with Ada.Text_IO; use Ada.Text_IO;

with ustrings; use ustrings;

with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

with GtkAda.Types; use GtkAda.Types;

with Gdk.Font; with Gdk.Color;
with Gtk.Check_Button;

with dispatcher;

with Glib, Glib.Glist; use Glib;

-- with Gtk.Notebook;

package body Window1_Pkg.Callbacks is

   use Gtk.Arguments;

   --------------------
   -- call_statusbar --
   --------------------

   procedure call_statusbar (text : in string)
   is
	my_id : context_ID := Get_Context_ID(window1.statusbar1,"Hallo");
	message : message_ID;
   begin
	message := Push(window1.statusbar1,my_id,text);
   end call_statusbar;

   --------------------------
   -- On_Beenden1_Activate --
   --------------------------

   procedure On_Beenden1_Activate
     (Object : access Gtk_Menu_Item_Record'Class)
   is

   begin
      sql.Pg.Disconnect;	-- terminate SQL-Connection
      Gtk.Main.Main_Quit;
   end On_Beenden1_Activate;

   -------------------------------------
   -- On_Really_Print_Always_Activate --
   -------------------------------------

   procedure On_Really_Print_Always_Activate
     (Object : access Gtk_Check_Menu_Item_Record'Class)
   is
   begin
      if ( Get_Active(Window1.Always1) ) then
         call_statusbar(" Always print the bill on paper");
      else
         call_statusbar(" Only generate tex-File. Never print on paper");
       end if;
   end On_Really_Print_Always_Activate;

   ------------------------
   -- On_Email1_Activate --
   ------------------------

   procedure On_Email1_Activate
     (Object : access Gtk_Menu_Item_Record'Class)
   is
   begin
      null;
   end On_Email1_Activate;

   -----------------------
   -- On_News1_Activate --
   -----------------------

   procedure On_News1_Activate
     (Object : access Gtk_Menu_Item_Record'Class)
   is
   begin
      null;
   end On_News1_Activate;

   ----------------------
   -- On_Web1_Activate --
   ----------------------

   procedure On_Web1_Activate
     (Object : access Gtk_Menu_Item_Record'Class)
   is
   begin
      null;
   end On_Web1_Activate;

   ------------------------
   -- On_Hilfe1_Activate --
   ------------------------

   procedure On_Hilfe1_Activate
     (Object : access Gtk_Menu_Item_Record'Class)
   is
   begin
      null;
   end On_Hilfe1_Activate;

   -----------------------
   -- On_About_Activate --
   -----------------------

   procedure On_About_Activate
     (Object : access Gtk_Menu_Item_Record'Class)
   is
   begin
	Show_All(Dialog1);
   end On_About_Activate;

   -----------------------
   -- On_Toggle_Printer --
   -----------------------

   procedure On_Toggle_Printer
     (Object : access Gtk_Widget_Record'Class;
      Params : Gtk.Arguments.Gtk_Args)
   is
   begin
      null;
   end On_Toggle_Printer;

   -------------------------
   -- On_Button10_Clicked --
   -------------------------

   procedure On_Button10_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
	ergebnis : Pg.Result_Type;      -- SQL-Result
	buffer : ustring;
	vorname : constant string := Get_Text(window1.entry13);
	name : constant string := Get_Text(window1.entry14);
	firma : constant string := Get_Text(window1.entry15);
   begin
     if (vorname /= "") OR (name /= "") OR (firma /= "") then
     sql.do_query("insert into kunden"&
	"(vorname,name,firma,strasse,plz,ort,tel,fax,funk,email,business)" &
	"values('" &
	vorname &"','"&name &"','"&
	Get_Text(window1.entry15)&
	"','"& Get_Text(window1.entry16)&
	"','"& Get_Text(window1.entry17)&
	"','"& Get_Text(window1.entry18)&
	"','"& Get_Text(window1.entry19)&
	"','"& Get_Text(window1.entry20)&
	"','"& Get_Text(window1.entry21)&
	"','"& Get_Text(window1.entry22)& 
	"','"& Boolean'Image(Get_Active(window1.checkbutton2)) &
	"');", ergebnis);

     sql.forget(Ergebnis);

     sql.do_query("select currval('kundenid')",ergebnis);
     Pg.Get(ergebnis,0,0,buffer);
     sql.forget(Ergebnis);

     call_statusbar(" Kundennummer fr " &
	vorname & " " & name & ": " & To_string(buffer));

    end if;

   end On_Button10_Clicked;

   -------------------------
   -- On_Button11_Clicked --
   -------------------------

   procedure On_Button11_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      Set_Text(window1.entry13,"");
      Set_Text(window1.entry14,"");
      Set_Text(window1.entry15,"");
      Set_Text(window1.entry16,"");
      Set_Text(window1.entry17,"");
      Set_Text(window1.entry18,"");
      Set_Text(window1.entry19,"");
      Set_Text(window1.entry20,"");
      Set_Text(window1.entry21,"");
      Set_Text(window1.entry22,"");
   end On_Button11_Clicked;

   -----------------
   -- Suche Kunde --
   -----------------

   function suche_kunde 
	(kundennummer,vorname,nachname : in string; query : in ustring)
	return ustring
   is
	firstentry : boolean := true;
	query2 : ustring := query;

   begin
       if ( kundennummer /= "" ) then                                          
        query2 := query2 & "kundennummer='" & kundennummer & "' ";      
                firstentry := false;                                           
     end if;                                                                   
                                                                               
     if ( vorname /= "" ) then                                                 
        if ( firstentry = true ) then                                          
                query2 := query2 & "vorname='" & vorname & "' ";              
                firstentry := false;                                           
        else                                                                   
                query2 := query2 & "AND vorname='" & vorname & "' ";          
        end if;                                                                
     end if;                                                                   
                                                                               
    if ( nachname /= "" ) then                                                 
        if ( firstentry = true ) then                                          
                query2 := query2 & "name='" & nachname & "' ";               
                firstentry := false;                                           
        else                                                                   
                query2 := query2 & "AND name='" & nachname & "' ";           
        end if;                                                                
     end if;                                                                   
       return query2;
                                 
    end suche_kunde;

   ------------------------------
   -- On_Suchdenkunden_Clicked --
   ------------------------------

   procedure On_Suchdenkunden_Clicked
     (Object : access Gtk_Button_Record'Class)
   is

	procedure hole_kundendaten ( kundennummer : in String ) is

	query : constant string := "select * from kunden where " &
	"kundennummer=" & kundennummer;

	ergebnis : Pg.Result_Type;
	buffer : ustring;

	begin
		sql.do_query(query,ergebnis);

-- rewrite the following, it is ugly.

			sql.Pg.Get(ergebnis,0,0,buffer);
			Set_Text(window1.entry26, To_String(buffer)); 

                        sql.Pg.Get(ergebnis,0,1,buffer);        
                        Set_Text(window1.entry27, To_String(buffer));

                        sql.Pg.Get(ergebnis,0,2,buffer);                       
                        Set_Text(window1.entry28, To_String(buffer));

                        sql.Pg.Get(ergebnis,0,3,buffer);                       
                        Set_Text(window1.entry29, To_String(buffer));

                        sql.Pg.Get(ergebnis,0,4,buffer);                       
                        Set_Text(window1.entry30, To_String(buffer));

                        sql.Pg.Get(ergebnis,0,5,buffer);                       
                        Set_Text(window1.entry31, To_String(buffer));

                        sql.Pg.Get(ergebnis,0,6,buffer);                       
                        Set_Text(window1.entry32, To_String(buffer));

                        sql.Pg.Get(ergebnis,0,7,buffer);                       
                        Set_Text(window1.entry33, To_String(buffer));

                        sql.Pg.Get(ergebnis,0,8,buffer);                       
                        Set_Text(window1.entry34, To_String(buffer));

                        sql.Pg.Get(ergebnis,0,9,buffer);                       
                        Set_Text(window1.entry35, To_String(buffer));

                        sql.Pg.Get(ergebnis,0,10,buffer);                      
                        Set_Text(window1.entry36, To_String(buffer));

		sql.Forget(ergebnis);
	end hole_kundendaten;


     query : ustring := To_Unbounded_String("select kundennummer from " &
                                            "kunden where ");
     kundennummer : constant string := Get_Text(Window1.entry23);
     vorname : constant string := Get_Text(Window1.entry24);
     nachname : constant string := Get_Text(Window1.entry25);

     ergebnis : Pg.Result_Type;                                                
                                                                               
     buffer : ustring;                                 

  begin
      
     if kundennummer = "" AND vorname = "" AND nachname = "" then

	call_statusbar(" Enter search-string");
     else

     query := suche_kunde(kundennummer,vorname,nachname,query);
  
      sql.do_query(To_string(query) & ";", ergebnis);                        

        	sql.Pg.Get(ergebnis,0,0,buffer);               
        	Pg.Forget(ergebnis);                                           

		if ( buffer /= "" ) then
			hole_kundendaten(To_String(buffer));
			call_statusbar(" Kunde gefunden");
			Set_Page(Window1.Notebook2, -1);
		else
			call_statusbar(" Kunde nicht gefunden");
		end if;

      end if;

   end On_Suchdenkunden_Clicked;


   ----------------------------
   -- On_Mail_Client_Pressed --
   ----------------------------

   procedure On_Mail_Client_Pressed
     (Object : access Gtk_Button_Record'Class)
   is
	email : constant string := Get_Text(window1.entry36);
   begin
      if email /= "" then
         dispatcher.send_email_to_client(email);
      else
         call_statusbar(" Client has no Email-address");
      end if;

   end On_Mail_Client_Pressed;

   -------------------------
   -- On_Modkunde_Clicked --
   -------------------------

   procedure On_Modkunde_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
	ergebnis : Pg.Result_Type;
   begin
        sql.do_query("update kunden "&                                    
	"set vorname='" &                    
	Get_Text(window1.entry27)&"',name='"&Get_Text(window1.entry28)&
	"',firma='"& Get_Text(window1.entry29)&               
	"',strasse='"& Get_Text(window1.entry30)&                              
	"',plz='"& Get_Text(window1.entry31)&                                  
	"',ort='"& Get_Text(window1.entry32)&                                  
	"',tel='"& Get_Text(window1.entry33)&                                  
	"',fax='"& Get_Text(window1.entry34)&                             
	"',funk='"& Get_Text(window1.entry35)&      
	"',email='"& Get_Text(window1.entry36)& "' where kundennummer=" &
	Get_Text(window1.entry26) &";", ergebnis);              
	sql.forget(ergebnis);
	call_statusbar(" Kunde gendert");
   end On_Modkunde_Clicked;

   ----------------------------
   -- On_Neurechnung_Clicked --
   ----------------------------

   procedure On_Neurechnung_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
	ergebnis : Pg.Result_Type;
	query : ustring := To_UString("select kundennummer from kunden " &
                                     "where ");
	kundennummer : constant string := Get_Text(window1.entry37);
	vorname : constant string := Get_Text(window1.entry38);
	nachname : constant string := Get_Text(window1.entry39);
	buffer : ustring;

   begin
     query := suche_kunde(kundennummer,vorname,nachname,query);
     sql.do_query(To_String(query),ergebnis);
                sql.Pg.Get(ergebnis,0,0,buffer);                        
                Pg.Forget(ergebnis);               

     if ( buffer /= "" ) then

       query := "insert into rechnung (kundennummer) values('" & buffer &
		"');" ;
	sql.do_query(To_string(query),ergebnis);
	Pg.Forget(ergebnis);

	query := To_Ustring("select currval('rechnungsid')");
	sql.do_query(To_string(query),ergebnis);
	sql.Pg.Get(ergebnis,0,0,buffer);
	Pg.Forget(ergebnis);
	Set_Text(window1.entry42,To_String(buffer));
	call_statusbar(" Neue Rechnung angelegt");
	Next_Page(window1.notebook3); 
    else
        call_statusbar(" Kunde nicht gefunden");
    end if;

  end On_Neurechnung_Clicked;

   -----------------------------
   -- On_Posten_Hinzu_Clicked --
   -----------------------------

   procedure On_Posten_Hinzu_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
	menge : constant string := Get_Text(window1.entry45);
	artbez : constant string := Get_Text(window1.entry44);
	epreis : constant string := Get_Text(window1.entry43);
	rechnr : constant string := Get_text(window1.entry42);

	ergebnis : Pg.Result_Type;
	buffer : ustring;
	query : ustring := To_Ustring("insert into rechnungsposten values('") &
		rechnr & "','" & artbez & "','" & epreis & "','" & 
		menge & "');";
   begin

      sql.do_query(To_String(query),ergebnis);
      Pg.Forget(ergebnis);
      call_statusbar(menge & " Artikel  " & 
      epreis & " in Rechnung " & rechnr & " hinzugefgt");
   end On_Posten_Hinzu_Clicked;

   --------------------------------
   -- On_Rechnung_Fertig_Clicked --
   --------------------------------

   procedure On_Rechnung_Fertig_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      Set_Text(window1.entry52,Get_Text(window1.entry42));
      Clicked(window1.button16);
      Clicked(window1.button19); -- Rechnungsdetails setzen
      Set_Page(Window1.Notebook3,2);
   end On_Rechnung_Fertig_Clicked;


   -----------------------
   -- on_zeige_rechnung --
   -----------------------

   function on_zeige_rechnung return string
   is
        ergebnis : Pg.Result_Type;
        rechnr : constant string := Get_Text(window1.entry52);

        buffer : ustring := dispatcher.hole_knr (rechnr);

        buffer2,buffer3,buffer4 : ustring;

        query : ustring := "select vorname,name,firma,strasse," &
                "plz,ort from kunden where kundennummer='" & buffer & "';" ;

        row : Gint;
   begin

    call_statusbar("");
    sql.do_query(To_String(query),ergebnis);
    Pg.Get(ergebnis,0,0,buffer);
    Pg.Get(ergebnis,0,1,buffer2);

    Set_Text(window1.entry53,To_string(buffer & " " & buffer2));

    Pg.Get(ergebnis,0,2,buffer);
    Set_Text(window1.entry54,To_string(buffer));

    Pg.Get(ergebnis,0,3,buffer);
    Set_Text(window1.entry55,To_string(buffer));

    Pg.Get(ergebnis,0,4,buffer);
    Pg.Get(ergebnis,0,5,buffer2);

    Set_Text(window1.entry56,To_string(buffer & " " & buffer2));

    Pg.Forget(ergebnis);

  -- fill the clist

    query := To_Ustring("select menge,artikelname,einzelpreis," &
	     "menge*einzelpreis" &
             " as gesamt from rechnungsposten where rechnungsnummer='" & 
	     rechnr & "';" );

    sql.do_query(To_String(query),ergebnis);

    Freeze(window1.clist3);
    Gtk.Clist.Clear(window1.clist3);
    for I in 0 .. ergebnis.Tuples_Qt-1 loop
    	Pg.Get(ergebnis,I,0,buffer);
	Pg.Get(ergebnis,I,1,buffer2);
	Pg.Get(ergebnis,I,2,buffer3);
	Pg.Get(ergebnis,I,3,buffer4);
	row := Gtk.Clist.Append(window1.clist3,To_string(buffer) +
						To_string(buffer2) +
						To_string(buffer3) +
						To_string(buffer4) );

    end loop;
    Pg.Forget(ergebnis);

    Thaw(window1.clist3);

    query := To_Ustring("select sum(einzelpreis*menge) as gesamt from " &
             "rechnungsposten where rechnungsnummer='" & rechnr & "';" );

   sql.do_query(To_String(query),ergebnis);

   Pg.Get(ergebnis,0,0,buffer);
   Set_Text(window1.entry57,To_String(buffer));
   Pg.Forget(ergebnis);

   return rechnr;

 end on_zeige_rechnung;


   -------------------------
   -- fill_details_widget --
   -------------------------

   procedure fill_details_widget (rechnr : in string)
   is
	ergebnis : Pg.Result_Type;
	delsuccess : boolean;
	buffer : ustring;
	query : ustring := To_Ustring("select datum,zahldatum," &
		"mitarbeiter,status,mahnungstyp,kommentar from rechnung " &
		"where rechnungsnummer='" & rechnr & "';" );
	
   begin

	Set_Text(window1.entry58,rechnr);

	sql.do_query(To_string(query),ergebnis);

	Pg.Get(ergebnis,0,0,buffer);
	if (buffer /= "") then
		Set_Text(window1.entry59,To_String(buffer));
	  else
		Set_Text(window1.entry59,dispatcher.datum(0));
	end if;

	Pg.Get(ergebnis,0,1,buffer);
	if (buffer /= "") then
		Set_Text(window1.entry60,To_String(buffer));
	  else
		Set_Text(window1.entry60,dispatcher.datum(14));
	end if;

	Pg.Get(ergebnis,0,2,buffer);
	Set_Text(window1.entry61,To_String(buffer));

	Pg.Get(ergebnis,0,3,buffer);
	Set_Text(window1.entry62,To_String(buffer));

	Pg.Get(ergebnis,0,4,buffer);
	if buffer /= "t" then
		Set_Active(window1.checkbutton1,false);
	else
		Set_Active(window1.checkbutton1,true);
	end if;

	Pg.Get(ergebnis,0,5,buffer);

	Freeze(window1.text1);

	Set_Point(window1.text1,0);
	delsuccess := Forward_Delete(window1.text1,Get_Length(window1.text1));

	Gtk.Text.Insert(window1.text1,
		Gdk.Font.Null_Font,
		Gdk.Color.Null_Color,
		Gdk.Color.Null_Color,
		To_String(buffer));

	Thaw(window1.text1);

	Pg.Forget(ergebnis);

   end fill_details_widget;

   -------------------------------
   -- On_Zeige_Rechnung_Clicked --
   -------------------------------

   procedure On_Zeige_Rechnung_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
        rechnr : constant string := on_zeige_rechnung;

        ergebnis : Pg.Result_Type;

   query : constant string := "update rechnung set gesamtbetrag=(select " &
        "sum(einzelpreis*menge) from rechnungsposten where " &
        "rechnungsnummer='" & rechnr & "') where rechnungsnummer='" &
        rechnr & "';" ;


   begin

   sql.do_query(query,ergebnis);
   Pg.Forget(ergebnis);

   fill_details_widget(rechnr);

   end On_Zeige_Rechnung_Clicked;
	
   ----------------------
   -- On_Print_Clicked --
   ----------------------

   procedure On_Print_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
	rechnr : constant string := Get_Text(window1.entry52);
   begin
     if ( rechnr /= "" ) then
      dispatcher.printbill(rechnr);
      call_statusbar(" File /tmp/" & rechnr & ".tex created");
      if ( Get_Active(window1.Always1) ) then
		dispatcher.my_C_system("cd /tmp && latex /tmp/" & rechnr & ".tex && dvips /tmp/" & rechnr & ".dvi &");
      end if;
     end if;
   end On_Print_Clicked;

   -------------------------------
   -- On_Setbilldetails_Clicked --
   -------------------------------

   procedure On_Setbilldetails_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
	ergebnis : Pg.Result_Type;
	query : ustring;

   begin
      query := To_Ustring("update rechnung set datum='" &
		Get_Text(window1.entry59) & "',zahldatum='" &
		Get_Text(window1.entry60) & "',mitarbeiter='" &
		Get_Text(window1.entry61) & "',status='" &
		Get_Text(window1.entry62) & "',mahnungstyp='");

      if Get_Active(window1.checkbutton1) = true then
		query := query & "t',";
	else
		query := query & "f',";
      end if;

      query := query & "kommentar='" & Get_Chars(window1.text1) &
		"' where rechnungsnummer='" &
		Get_Text(window1.entry58) & "';" ;

      sql.do_query(To_String(query),ergebnis);
      Pg.Forget(ergebnis);
      call_statusbar(" Rechnungsdetails gendert");

   end On_Setbilldetails_Clicked;

   ---------------------------------
   -- On_Billdetailsreset_Clicked --
   ---------------------------------

   procedure On_Billdetailsreset_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
	rechnr : constant string := Get_Text(window1.entry58);
   begin
      if rechnr /= "" then
      	fill_details_widget(rechnr);
        call_statusbar(" Ursprngliche Werte angezeigt");
      end if;

   end On_Billdetailsreset_Clicked;

   --------------------
   -- On_Search_Bill --
   --------------------

   procedure On_Search_Bill
     (Object : access Gtk_Button_Record'Class)
   is
      knr : ustring := To_ustring(Get_Text(window1.entry63));
      vorname : constant string := Get_Text(window1.entry64);
      name : constant string := Get_Text(window1.entry65);	
      query : ustring := To_Ustring("select kundennummer from kunden where ");

      ergebnis : pg.result_Type;
      buffer,buffer2,buffer3 : ustring;

      row : Gint;

   begin

	if knr = "" AND name = "" AND vorname = "" then
		query := To_Ustring("select rechnungsnummer,datum,kommentar" &
			" from rechnung order by rechnungsnummer;");
	else

		if (knr = "") then
	          query := suche_kunde(To_string(knr),vorname,name,query);
		  sql.do_query(To_String(query),ergebnis);
		  Pg.Get(ergebnis,0,0,buffer);
		  Pg.Forget(Ergebnis);
		  knr := buffer;
	         end if;

		query := "select rechnungsnummer,datum,kommentar from " & 
		"rechnung where kundennummer='" & knr & "';" ;

	end if;

	sql.do_query(To_String(query),ergebnis);

	Freeze(window1.clist4);
	Gtk.Clist.Clear(window1.clist4);

	for I in 0 .. Ergebnis.Tuples_Qt-1 loop
		Pg.Get(ergebnis,I,0,buffer);
		Pg.Get(ergebnis,I,1,buffer2);
		Pg.Get(ergebnis,I,2,buffer3);
		row := Gtk.Clist.Append(window1.clist4, To_string(buffer) +
		To_string(buffer2) + To_string(buffer3));
	end loop;
	sql.Forget(ergebnis);

	Thaw(window1.clist4);

   end On_Search_Bill;

   --------------------------
   -- On_Clist4_Select_Row --
   --------------------------

   procedure On_Clist4_Select_Row
     (Object : access Gtk_Clist_Record'Class;
      Params : Gtk.Arguments.Gtk_Args)
   is
      Arg1 : Gint := To_Gint (Params, 1);
      Arg2 : Gint := To_Gint (Params, 2);
      Arg3 : Gdk_Event := To_Event (Params, 3);

      rechnr : ustring;

   begin
      call_statusbar(" Rechnung wird angezeigt");
      Set_text(window1.entry52, Get_Text(window1.clist4,arg1,0));
      rechnr := To_ustring(on_zeige_rechnung);	-- main call
      fill_details_widget(To_String(rechnr)); -- setzt die details
      Set_Page(window1.notebook3,2);      
   end On_Clist4_Select_Row;

   ---------------------
   -- Sortmode_Change --
   ---------------------

   procedure Sortmode_Change
     (Object : access Gtk_Clist_Record'Class;
      Params : Gtk.Arguments.Gtk_Args)
   is
      Arg1 : Gint := To_Gint (Params, 1);
   begin
      Freeze(window1.clist4);

      if ( Arg1 = Get_Sort_Column(window1.clist4) ) then
		if ( Get_Sort_Type(window1.clist4) = Ascending ) then
			Set_Sort_Type(window1.clist4,Descending);
		else
			Set_Sort_Type(window1.clist4,Ascending);
		end if;
      else
		Set_Sort_Column(window1.clist4,Arg1);
      end if;

      Sort(window1.clist4);
      Thaw(window1.clist4);
   end Sortmode_Change;

   --------------------------------
   -- On_Delete_Todo_Row_Clicked --
   --------------------------------

   procedure On_Delete_Todo_Row_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
	use Gtk.Enums.Gint_List;
	row : Gint;
	ergebnis : Pg.Result_Type;
	
	query : ustring := To_Ustring("delete from todo where what='");

	Liste : Gtk.Enums.Gint_List.Glist;

  begin

	freeze (window1.clist2);
	loop
	  Liste := Get_Selection (window1.clist2);
	  exit when Length (Liste) = 0;
		row := Get_Data (First (Liste));
		query := query & Get_Text(window1.clist2,row,1) & "';" ;
		sql.do_query(To_String(query),ergebnis);
		Pg.Forget(ergebnis);
		Remove (window1.clist2,row);
		call_statusbar(" Eintrag"& Gint'Image (row+1) &" gelscht");
	  exit when Get_Selection_Mode (window1.clist2) = Selection_Browse;
	end loop;

	Thaw (window1.clist2);

   end On_Delete_Todo_Row_Clicked;

   --------------------
   -- fill_todo_list --
   --------------------

  procedure fill_todo_list
   is
	ergebnis : Pg.Result_Type;
	priority,what : ustring;
	row : Gint;
	query : constant string := "select * from todo order by priority;" ;

   begin
      sql.do_query(query,ergebnis);

	Freeze(window1.clist2);
	Gtk.Clist.Clear(window1.clist2);

	for I in 0 .. ergebnis.Tuples_Qt-1 loop
		Pg.Get(ergebnis,I,0,priority);
		Pg.Get(ergebnis,I,1,what);
		row := Gtk.Clist.Append(window1.clist2, To_string(priority) +
			To_string(what) );
	end loop;

	Pg.Forget(ergebnis);

	Thaw(window1.clist2);

  end fill_todo_list;

   --------------------
   -- On_Reload_Todo --
   --------------------

   procedure On_Reload_Todo
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      fill_todo_list;
   end On_Reload_Todo;

   ------------------------
   -- On_Change_Priority --
   ------------------------

   procedure On_Change_Priority
     (Object : access Gtk_Button_Record'Class)
   is
      use Gtk.Enums.Gint_List;
      Liste : Gtk.Enums.Gint_List.Glist;
      priority : constant string := Get_Text(Get_Entry(window1.combo1));
      query : ustring;
      row : Gint;	
      ergebnis : Pg.Result_Type;

   begin
        freeze (window1.clist2);                                               
        loop                                                                   
          Liste := Get_Selection (window1.clist2);                             
          exit when Length (Liste) = 0;                                        
                row := Get_Data (First (Liste));                               
		query := To_Ustring("update todo set priority='" &
		priority & "' where what='" &
		Get_Text(window1.clist2,row,1) & "';" );     
                sql.do_query(To_String(query),ergebnis);                    
                Pg.Forget(ergebnis);                                        
                Set_Text(window1.clist2,row,0,priority);                  
                call_statusbar(" Eintrag"& Gint'Image (row+1) &" gendert");
		Unselect_Row(window1.clist2,row,0);
          exit when Get_Selection_Mode (window1.clist2) = Selection_Browse;    
        end loop;                                                            
                                                                           
        Thaw (window1.clist2);                                            

   end On_Change_Priority;

   ----------------------------
   -- On_Todo_Insert_Clicked --
   ----------------------------

   procedure On_Todo_Insert_Clicked
     (Object : access Gtk_Button_Record'Class)
   is

	eintrag : constant string := Get_Text(window1.entry46);
	-- user : constant string := Get_Text(window1.entry47);
	priority : constant string := Get_Text(Get_Entry(window1.combo1));
	-- todo : constant string := "1";
	row : Gint;

	ergebnis : Pg.Result_Type;
	-- buffer : ustring;
	query : constant string := "insert into todo values('" & priority &
				   "','" & eintrag & "');" ;

  begin
    if eintrag /= "" then
	sql.do_query(query,ergebnis);
	Pg.Forget(ergebnis);
	row := Gtk.Clist.Append(window1.clist2, priority + eintrag);
	-- Gtk.Clist.Set_Text(window1.clist2,row,Gint(0),Gint'Image(row+1));
	call_statusbar(" Neuen Todo-Eintrag aufgenommen");
    end if;
   end On_Todo_Insert_Clicked;

   -------------------------
   -- On_Todo_Called_Show --
   -------------------------

   procedure On_Todo_Called_Show
     (Object : access Gtk_Label_Record'Class)
   is
    begin
	fill_todo_list;
   end On_Todo_Called_Show;

   -------------------
   -- On_Write_Mail --
   -------------------

   procedure On_Write_Mail
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      dispatcher.external(1);
   end On_Write_Mail;

   -------------------
   -- On_Browse_Web --
   -------------------

   procedure On_Browse_Web
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      dispatcher.external(2);
   end On_Browse_Web;

   ------------------
   -- On_Read_News --
   ------------------

   procedure On_Read_News
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      dispatcher.external(3);
   end On_Read_News;

   -------------------------
   -- On_Misc_Sql_Clicked --
   -------------------------

   procedure On_Misc_Sql_Clicked
     (Object : access Gtk_Button_Record'Class)
   is
	query : constant string := Get_Text(window1.entry66);
	ergebnis : Pg.Result_Type;
	buffer : ustring;
	delsuccess : boolean;

   begin
      sql.do_query(query,ergebnis);

      Freeze(window1.text2);		
 
      Set_Point(window1.text2,0);
      delsuccess := Forward_Delete(window1.text2,Get_Length(window1.text2));

      for I in 0 .. ergebnis.Tuples_Qt-1 loop
	for J in 0 .. ergebnis.Fields_Qt-1 loop
		Pg.Get(ergebnis,I,J,buffer);
		Gtk.Text.Insert(window1.text2,
		Gdk.Font.Null_Font,                                      
                Gdk.Color.Null_Color,                                    
                Gdk.Color.Null_Color,                                    
                To_String(buffer & ASCII.HT));
	end loop;
	Gtk.Text.Insert(window1.text2,
          Gdk.Font.Null_Font,                                         
          Gdk.Color.Null_Color,                                       
          Gdk.Color.Null_Color,                                      
          ASCII.LF & ASCII.Nul);         
       end loop;

      Thaw(window1.text2);
      Pg.Forget(ergebnis);
      call_statusbar(" SQL-Command executed");
   end On_Misc_Sql_Clicked;

end Window1_Pkg.Callbacks;
